*** a/src/backend/parser/analyze.c
--- b/src/backend/parser/analyze.c
***************
*** 412,417 **** transformInsertStmt(ParseState *pstate, InsertStmt *stmt)
--- 412,426 ----
  	/* There can't be any outer WITH to worry about */
  	Assert(pstate->p_ctenamespace == NIL);
  
+ 	/*
+ 	 * This should be disallowed by the parser, but check anyway for
+ 	 * the sake of paranoia.
+ 	 */
+ 	if (stmt->relation->sample_info)
+ 		ereport(ERROR,
+ 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 				errmsg("TABLESAMPLE cannot be specified for INSERT")));
+ 
  	qry->commandType = CMD_INSERT;
  	pstate->p_is_insert = true;
  
*** a/src/backend/parser/gram.y
--- b/src/backend/parser/gram.y
***************
*** 402,407 **** static void processCASbits(int cas_bits, int location, const char *constrType,
--- 402,411 ----
  %type <ielem>	index_elem
  %type <node>	table_ref
  %type <jexpr>	joined_table
+ %type <node>	opt_table_sample
+ %type <range>	relation_expr_opt_sample
+ %type <value>	sample_method
+ %type <value>	opt_repeatable_clause
  %type <range>	relation_expr
  %type <range>	relation_expr_opt_alias
  %type <target>	target_el single_set_clause set_target insert_column_item
***************
*** 497,503 **** static void processCASbits(int cas_bits, int location, const char *constrType,
  	AGGREGATE ALL ALSO ALTER ALWAYS ANALYSE ANALYZE AND ANY ARRAY AS ASC
  	ASSERTION ASSIGNMENT ASYMMETRIC AT ATTRIBUTE AUTHORIZATION
  
! 	BACKWARD BEFORE BEGIN_P BETWEEN BIGINT BINARY BIT
  	BOOLEAN_P BOTH BY
  
  	CACHE CALLED CASCADE CASCADED CASE CAST CATALOG_P CHAIN CHAR_P
--- 501,507 ----
  	AGGREGATE ALL ALSO ALTER ALWAYS ANALYSE ANALYZE AND ANY ARRAY AS ASC
  	ASSERTION ASSIGNMENT ASYMMETRIC AT ATTRIBUTE AUTHORIZATION
  
! 	BACKWARD BEFORE BEGIN_P BERNOULLI BETWEEN BIGINT BINARY BIT
  	BOOLEAN_P BOTH BY
  
  	CACHE CALLED CASCADE CASCADED CASE CAST CATALOG_P CHAIN CHAR_P
***************
*** 563,569 **** static void processCASbits(int cas_bits, int location, const char *constrType,
  	STATEMENT STATISTICS STDIN STDOUT STORAGE STRICT_P STRIP_P SUBSTRING
  	SYMMETRIC SYSID SYSTEM_P
  
! 	TABLE TABLES TABLESPACE TEMP TEMPLATE TEMPORARY TEXT_P THEN TIME TIMESTAMP
  	TO TRAILING TRANSACTION TREAT TRIGGER TRIM TRUE_P
  	TRUNCATE TRUSTED TYPE_P TYPES_P
  
--- 567,573 ----
  	STATEMENT STATISTICS STDIN STDOUT STORAGE STRICT_P STRIP_P SUBSTRING
  	SYMMETRIC SYSID SYSTEM_P
  
! 	TABLE TABLES TABLESAMPLE TABLESPACE TEMP TEMPLATE TEMPORARY TEXT_P THEN TIME TIMESTAMP
  	TO TRAILING TRANSACTION TREAT TRIGGER TRIM TRUE_P
  	TRUNCATE TRUSTED TYPE_P TYPES_P
  
***************
*** 9312,9318 **** from_list:
  /*
   * table_ref is where an alias clause can be attached.
   */
! table_ref:	relation_expr opt_alias_clause
  				{
  					$1->alias = $2;
  					$$ = (Node *) $1;
--- 9316,9322 ----
  /*
   * table_ref is where an alias clause can be attached.
   */
! table_ref:  relation_expr_opt_sample opt_alias_clause
  				{
  					$1->alias = $2;
  					$$ = (Node *) $1;
***************
*** 9577,9582 **** join_qual:	USING '(' name_list ')'					{ $$ = (Node *) $3; }
--- 9581,9647 ----
  			| ON a_expr								{ $$ = $2; }
  		;
  
+ /*
+  * We want to allow the TABLESAMPLE clause to be specified for 
+  * SELECT, DELETE, and UPDATE, but not for DDL commands. Therefore,
+  * we add a new production that is "relation_expr + optional TABLESAMPLE",
+  * and use that anywhere we'd like to allow a TABLESAMPLE clause to be specified.
+  */
+ 
+ relation_expr_opt_sample:
+ 			relation_expr opt_table_sample
+ 			{
+ 				$$ = $1;
+ 				$$->sample_info = (TableSampleInfo *) $2;
+ 			}
+ 		;
+ 
+ opt_table_sample:
+ 			TABLESAMPLE sample_method '('Iconst')' opt_repeatable_clause
+ 			{
+ 				TableSampleInfo *n = makeNode(TableSampleInfo);
+ 
+ 				if( $2 == 1 )
+ 					n->sample_method = SAMPLE_BERNOULLI;
+ 				else if( $2 == 2 )
+ 					n->sample_method = SAMPLE_SYSTEM;
+ 				else
+ 					ereport(ERROR,
+ 							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 							 errmsg("Sampling method not supported")));
+ 
+ 				n->sample_percent = $4;
+ 				if($4 > 100)
+ 					ereport(ERROR,
+ 							(errcode(ERRCODE_INVALID_SAMPLE_SIZE),
+ 							 errmsg("TABLESAMPLE percentage"
+ 									"be greater than 100")));
+ 				if($4 < 0)
+ 					ereport(ERROR,
+ 							(errcode(ERRCODE_INVALID_SAMPLE_SIZE),
+ 							 errmsg("TABLESAMPLE percentage must"
+ 									"be greater than 0")));
+ 
+ 				if($6 != NULL)
+ 				{
+ 					n->is_repeatable = true;
+ 					n->repeat_seed = intVal($6);
+ 				}
+ 
+ 				$$ = (Node *)n;
+ 			}
+ 			| /*EMPTY*/				{ $$ = NULL; }
+ 		;
+ 
+ sample_method:
+ 			BERNOULLI				{ $$ = 1; }
+ 			| SYSTEM_P 				{ $$ = 2; }
+ 		;
+ 
+ opt_repeatable_clause:
+ 			REPEATABLE '('Iconst')' { $$ = makeInteger($3); }
+ 			| /*EMPTY*/				{ $$ = NULL; }
+ 		;
  
  relation_expr:
  			qualified_name
***************
*** 9625,9642 **** relation_expr_list:
   * has, causing the parser to prefer to reduce, in effect assuming that the
   * SET is not an alias.
   */
! relation_expr_opt_alias: relation_expr					%prec UMINUS
  				{
  					$$ = $1;
  				}
! 			| relation_expr ColId
  				{
  					Alias *alias = makeNode(Alias);
  					alias->aliasname = $2;
  					$1->alias = alias;
  					$$ = $1;
  				}
! 			| relation_expr AS ColId
  				{
  					Alias *alias = makeNode(Alias);
  					alias->aliasname = $3;
--- 9690,9707 ----
   * has, causing the parser to prefer to reduce, in effect assuming that the
   * SET is not an alias.
   */
! relation_expr_opt_alias: relation_expr_opt_sample					%prec UMINUS
  				{
  					$$ = $1;
  				}
! 			| relation_expr_opt_sample ColId
  				{
  					Alias *alias = makeNode(Alias);
  					alias->aliasname = $2;
  					$1->alias = alias;
  					$$ = $1;
  				}
! 			| relation_expr_opt_sample AS ColId
  				{
  					Alias *alias = makeNode(Alias);
  					alias->aliasname = $3;
***************
*** 12385,12390 **** unreserved_keyword:
--- 12450,12456 ----
  			| BACKWARD
  			| BEFORE
  			| BEGIN_P
+ 			| BERNOULLI
  			| BY
  			| CACHE
  			| CALLED
***************
*** 12539,12545 **** unreserved_keyword:
  			| RELATIVE_P
  			| RELEASE
  			| RENAME
- 			| REPEATABLE
  			| REPLACE
  			| REPLICA
  			| RESET
--- 12605,12610 ----
***************
*** 12712,12717 **** type_func_name_keyword:
--- 12777,12783 ----
  			| OVERLAPS
  			| RIGHT
  			| SIMILAR
+ 			| TABLESAMPLE
  			| VERBOSE
  		;
  
***************
*** 12780,12785 **** reserved_keyword:
--- 12846,12852 ----
  			| PLACING
  			| PRIMARY
  			| REFERENCES
+ 			| REPEATABLE
  			| RETURNING
  			| SELECT
  			| SESSION_USER
*** a/src/backend/parser/parse_clause.c
--- b/src/backend/parser/parse_clause.c
***************
*** 190,195 **** setTargetTable(ParseState *pstate, RangeVar *relation,
--- 190,201 ----
  										relation->alias, inh, false);
  	pstate->p_target_rangetblentry = rte;
  
+ 	/*
+ 	 * Minor kludge: addRangeTableEntryForRelation() can't see the
+ 	 * TABLESAMPLE clause, so attach it to the new RTE manually.
+ 	 */
+ 	rte->sample_info = relation->sample_info;
+ 
  	/* assume new rte is at end */
  	rtindex = list_length(pstate->p_rtable);
  	Assert(rte == rt_fetch(rtindex, pstate->p_rtable));
*** a/src/backend/parser/parse_relation.c
--- b/src/backend/parser/parse_relation.c
***************
*** 330,336 **** searchRangeTableForRel(ParseState *pstate, RangeVar *relation)
  
  			if (rte->rtekind == RTE_RELATION &&
  				OidIsValid(relId) &&
! 				rte->relid == relId)
  				return rte;
  			if (rte->rtekind == RTE_CTE &&
  				cte != NULL &&
--- 330,337 ----
  
  			if (rte->rtekind == RTE_RELATION &&
  				OidIsValid(relId) &&
! 				rte->relid == relId &&
! 				equal(rte->sample_info, relation->sample_info))
  				return rte;
  			if (rte->rtekind == RTE_CTE &&
  				cte != NULL &&
***************
*** 995,1000 **** addRangeTableEntry(ParseState *pstate,
--- 996,1002 ----
  	rel = parserOpenTable(pstate, relation, lockmode);
  	rte->relid = RelationGetRelid(rel);
  	rte->relkind = rel->rd_rel->relkind;
+ 	rte->sample_info = relation->sample_info;
  
  	/*
  	 * Build the list of effective column names using user-supplied aliases
***************
*** 1055,1060 **** addRangeTableEntryForRelation(ParseState *pstate,
--- 1057,1063 ----
  	rte->alias = alias;
  	rte->relid = RelationGetRelid(rel);
  	rte->relkind = rel->rd_rel->relkind;
+ 	rte->sample_info = NULL;
  
  	/*
  	 * Build the list of effective column names using user-supplied aliases
***************
*** 1110,1115 **** addRangeTableEntryForSubquery(ParseState *pstate,
--- 1113,1119 ----
  
  	rte->rtekind = RTE_SUBQUERY;
  	rte->relid = InvalidOid;
+ 	rte->sample_info = NULL;
  	rte->subquery = subquery;
  	rte->alias = alias;
  
***************
*** 1189,1194 **** addRangeTableEntryForFunction(ParseState *pstate,
--- 1193,1199 ----
  
  	rte->rtekind = RTE_FUNCTION;
  	rte->relid = InvalidOid;
+ 	rte->sample_info = NULL;
  	rte->subquery = NULL;
  	rte->funcexpr = funcexpr;
  	rte->funccoltypes = NIL;
***************
*** 1323,1328 **** addRangeTableEntryForValues(ParseState *pstate,
--- 1328,1334 ----
  
  	rte->rtekind = RTE_VALUES;
  	rte->relid = InvalidOid;
+ 	rte->sample_info = NULL;
  	rte->subquery = NULL;
  	rte->values_lists = exprs;
  	rte->values_collations = collations;
***************
*** 1403,1408 **** addRangeTableEntryForJoin(ParseState *pstate,
--- 1409,1415 ----
  
  	rte->rtekind = RTE_JOIN;
  	rte->relid = InvalidOid;
+ 	rte->sample_info = NULL;
  	rte->subquery = NULL;
  	rte->jointype = jointype;
  	rte->joinaliasvars = aliasvars;
*** a/src/backend/utils/adt/ruleutils.c
--- b/src/backend/utils/adt/ruleutils.c
***************
*** 2174,2179 **** deparse_context_for(const char *aliasname, Oid relid)
--- 2174,2180 ----
  	rte = makeNode(RangeTblEntry);
  	rte->rtekind = RTE_RELATION;
  	rte->relid = relid;
+ 	rte->sample_info = NULL;
  	rte->relkind = RELKIND_RELATION;	/* no need for exactness here */
  	rte->eref = makeAlias(aliasname, NIL);
  	rte->lateral = false;
***************
*** 6719,6724 **** get_from_clause_item(Node *jtnode, Query *query, deparse_context *context)
--- 6720,6750 ----
  			 */
  			get_from_clause_alias(rte->alias, rte, context);
  		}
+ 
+ 		if (rte->sample_info)
+ 		{
+ 			TableSampleInfo		*sample_info = rte->sample_info;
+ 			const char			*method_name;
+ 
+ 			Assert(rte->rtekind == RTE_RELATION);
+ 
+ 			switch(sample_info->sample_method)
+ 			{
+ 				case SAMPLE_BERNOULLI:
+ 					method_name = "BERNOULLI";
+ 					break;
+ 				case SAMPLE_SYSTEM:
+ 					method_name = "SYSTEM";
+ 					break;
+ 				default:
+ 					elog(ERROR, "unrecognized sample method: %s", 
+ 						 (int) sample_info->sample_method);
+ 					method_name = NULL;
+ 			}
+ 
+ 			appendStringInfo(buf, " TABLESAMPLE %s (%d)",
+ 							 method_name, sample_info->sample_percent);
+ 		}
  	}
  	else if (IsA(jtnode, JoinExpr))
  	{
*** a/src/backend/utils/misc/Makefile
--- b/src/backend/utils/misc/Makefile
***************
*** 15,21 **** include $(top_builddir)/src/Makefile.global
  override CPPFLAGS := -I. -I$(srcdir) $(CPPFLAGS)
  
  OBJS = guc.o help_config.o pg_rusage.o ps_status.o rbtree.o \
!        superuser.o timeout.o tzparser.o
  
  # This location might depend on the installation directories. Therefore
  # we can't subsitute it into pg_config.h.
--- 15,21 ----
  override CPPFLAGS := -I. -I$(srcdir) $(CPPFLAGS)
  
  OBJS = guc.o help_config.o pg_rusage.o ps_status.o rbtree.o \
!        superuser.o timeout.o tzparser.o sampleutils.o
  
  # This location might depend on the installation directories. Therefore
  # we can't subsitute it into pg_config.h.
*** /dev/null
--- b/src/backend/utils/misc/sampleutils.c
***************
*** 0 ****
--- 1,272 ----
+ /*-------------------------------------------------------------------------
+  *
+  * sampleutils.c
+  *	  Routines designed for TableSample Clause, containing Vitter's Reservoir
+  *	  Sampling Algo routines. Tablesample System, Bernoulli sampling and analyze
+  *	  is using these apis.
+  *
+  * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  *
+  * IDENTIFICATION
+  *	  src/backend/utils/misc/sampleutils.c
+  *
+  *-------------------------------------------------------------------------
+  */
+ #include "postgres.h"
+ 
+ #include "utils/sampleutils.h"
+ #include "storage/procarray.h"
+ #include "storage/bufmgr.h"
+ #include "utils/tqual.h"
+ #include "utils/rel.h"
+ 
+ #define MEM_OVERHEAD 100000000
+ 
+ 
+ /*
+  * BlockSampler_Init -- prepare for random sampling of blocknumbers
+  *
+  * BlockSampler is used for stage one of our new two-stage tuple
+  * sampling mechanism as discussed on pgsql-hackers 2004-04-02 (subject
+  * "Large DB").  It selects a random sample of samplesize blocks out of
+  * the nblocks blocks in the table.  If the table has less than
+  * samplesize blocks, all blocks are selected.
+  *
+  * Since we know the total number of blocks in advance, we can use the
+  * straightforward Algorithm S from Knuth 3.4.2, rather than Vitter's
+  * algorithm.
+  */
+ void
+ BlockSampler_Init(BlockSampler bs, BlockNumber nblocks, int samplesize)
+ {
+ 	bs->N = nblocks;			/* measured table size */
+ 
+ 	/*
+ 	 * If we decide to reduce samplesize for tables that have less or not much
+ 	 * more than samplesize blocks, here is the place to do it.
+ 	 */
+ 	bs->n = samplesize;
+ 	bs->t = 0;					/* blocks scanned so far */
+ 	bs->m = 0;					/* blocks selected so far */
+ }
+ 
+ bool
+ BlockSampler_HasMore(BlockSampler bs)
+ {
+ 	return (bs->t < bs->N) && (bs->m < bs->n);
+ }
+ 
+ BlockNumber
+ BlockSampler_Next(void *state, BlockSampler bs)
+ {
+ 	BlockNumber K = bs->N - bs->t;		/* remaining blocks */
+ 	int			k = bs->n - bs->m;		/* blocks still to sample */
+ 	double		p;				/* probability to skip block */
+ 	double		V;				/* random */
+ 
+ 	Assert(BlockSampler_HasMore(bs));	/* hence K > 0 and k > 0 */
+ 
+ 	if ((BlockNumber) k >= K)
+ 	{
+ 		/* need all the rest */
+ 		bs->m++;
+ 		return bs->t++;
+ 	}
+ 
+ 	/*----------
+ 	 * It is not obvious that this code matches Knuth's Algorithm S.
+ 	 * Knuth says to skip the current block with probability 1 - k/K.
+ 	 * If we are to skip, we should advance t (hence decrease K), and
+ 	 * repeat the same probabilistic test for the next block.  The naive
+ 	 * implementation thus requires an anl_random_fract() call for each block
+ 	 * number.	But we can reduce this to one anl_random_fract() call per
+ 	 * selected block, by noting that each time the while-test succeeds,
+ 	 * we can reinterpret V as a uniform random number in the range 0 to p.
+ 	 * Therefore, instead of choosing a new V, we just adjust p to be
+ 	 * the appropriate fraction of its former value, and our next loop
+ 	 * makes the appropriate probabilistic test.
+ 	 *
+ 	 * We have initially K > k > 0.  If the loop reduces K to equal k,
+ 	 * the next while-test must fail since p will become exactly zero
+ 	 * (we assume there will not be roundoff error in the division).
+ 	 * (Note: Knuth suggests a "<=" loop condition, but we use "<" just
+ 	 * to be doubly sure about roundoff error.)  Therefore K cannot become
+ 	 * less than k, which means that we cannot fail to select enough blocks.
+ 	 *----------
+ 	 */
+ 	V = anl_random_fract(state);
+ 	p = 1.0 - (double) k / (double) K;
+ 	while (V < p)
+ 	{
+ 		/* skip */
+ 		bs->t++;
+ 		K--;					/* keep K == N - t */
+ 
+ 		/* adjust p to be new cutoff point in reduced range */
+ 		p *= 1.0 - (double) k / (double) K;
+ 	}
+ 
+ 	/* select */
+ 	bs->m++;
+ 	return bs->t++;
+ }
+ 
+ 
+ 
+ /*
+  * These two routines embody Algorithm Z from "Random sampling with a
+  * reservoir" by Jeffrey S. Vitter, in ACM Trans. Math. Softw. 11, 1
+  * (Mar. 1985), Pages 37-57.  Vitter describes his algorithm in terms
+  * of the count S of records to skip before processing another record.
+  * It is computed primarily based on t, the number of records already read.
+  * The only extra state needed between calls is W, a random state variable.
+  *
+  * anl_init_selection_state computes the initial W value.
+  *
+  * Given that we've already read t records (t >= n), anl_get_next_S
+  * determines the number of records to skip before the next record is
+  * processed.
+  */
+ double
+ anl_init_selection_state(void *state, int n)
+ {
+ 	/* Initial value of W (for use when Algorithm Z is first applied) */
+ 	return exp(-log(anl_random_fract(state)) / n);
+ }
+ 
+ double
+ anl_get_next_S(void *state, double t, int n, double *stateptr)
+ {
+ 	double		S;
+ 
+ 	/* The magic constant here is T from Vitter's paper */
+ 	if (t <= (22.0 * n))
+ 	{
+ 		/* Process records using Algorithm X until t is large enough */
+ 		double		V,
+ 					quot;
+ 
+ 		V = anl_random_fract(state); /* Generate V */
+ 		S = 0;
+ 		t += 1;
+ 		/* Note: "num" in Vitter's code is always equal to t - n */
+ 		quot = (t - (double) n) / t;
+ 		/* Find min S satisfying (4.1) */
+ 		while (quot > V)
+ 		{
+ 			S += 1;
+ 			t += 1;
+ 			quot *= (t - (double) n) / t;
+ 		}
+ 	}
+ 	else
+ 	{
+ 		/* Now apply Algorithm Z */
+ 		double		W = *stateptr;
+ 		double		term = t - (double) n + 1;
+ 
+ 		for (;;)
+ 		{
+ 			double		numer,
+ 						numer_lim,
+ 						denom;
+ 			double		U,
+ 						X,
+ 						lhs,
+ 						rhs,
+ 						y,
+ 						tmp;
+ 
+ 			
+ 			U = anl_random_fract(state); /* Generate U and X */
+ 			X = t * (W - 1.0);
+ 			S = floor(X);		/* S is tentatively set to floor(X) */
+ 			/* Test if U <= h(S)/cg(X) in the manner of (6.3) */
+ 			tmp = (t + 1) / term;
+ 			lhs = exp(log(((U * tmp * tmp) * (term + S)) / (t + X)) / n);
+ 			rhs = (((t + X) / (term + S)) * term) / t;
+ 			if (lhs <= rhs)
+ 			{
+ 				W = rhs / lhs;
+ 				break;
+ 			}
+ 			/* Test if U <= f(S)/cg(X) */
+ 			y = (((U * (t + 1)) / term) * (t + S + 1)) / (t + X);
+ 			if ((double) n < S)
+ 			{
+ 				denom = t;
+ 				numer_lim = term + S;
+ 			}
+ 			else
+ 			{
+ 				denom = t - (double) n + S;
+ 				numer_lim = t + 1;
+ 			}
+ 			for (numer = t + S; numer >= numer_lim; numer -= 1)
+ 			{
+ 				y *= numer / denom;
+ 				denom -= 1;
+ 			}
+ 			W = exp(-log(anl_random_fract(state)) / n);		/* Generate W in advance */
+ 			if (exp(log(y) / n) <= (t + X) / t)
+ 				break;
+ 		}
+ 		*stateptr = W;
+ 	}
+ 	return S;
+ }
+ 
+ /* ---------------------------------------------------
+  * Random number generator
+  * ---------------------------------------------------
+  */
+ 
+ /* Select a random value R uniformly distributed in (0 - 1), for tablsample use */
+ double
+ anl_random_fract(void *state)
+ {
+ 	/* XXX: If the sample_random can work as good as random(), may merge,
+ 	 * but now, as sample_random surely needs improvement, we leave 
+ 	 * analzye.c and tablesample using different random generator.
+ 	 */
+ 	if(state == NULL)
+ 	{
+ 		return ((double) random() + 1) / ((double) MAX_RANDOM_VALUE + 2);
+ 	}else{
+ 		return sample_random(state);
+ 	}
+ }
+ 
+ /*
+  * Returns a randomly-generated trigger x, such that a <= x < b
+  */
+ int
+ get_rand_in_range(void *rand_state, int a, int b)
+ {
+ 	double rand = sample_random(rand_state);
+ 	return (rand * b) + a;
+ }
+ 
+ /*
+  * Random Number Seeding
+  */
+ void sample_set_seed(void *random_state, double seed)
+ {
+ 	/*     
+ 	 * XXX. This seeding algorithm could certainly be improved.
+ 	 * May need some effort on this.
+ 	 */    
+ 	seed += MEM_OVERHEAD; //seed must be large enough to make difference
+ 
+ 	memset(random_state, 0, sizeof(random_state));
+ 	memcpy(random_state,
+ 			&seed,
+ 			Min(sizeof(random_state), sizeof(seed)));
+ }
+ 
+ double sample_random(void *random_state)
+ {
+ 	return pg_erand48(random_state);
+ }
*** a/src/include/access/relscan.h
--- b/src/include/access/relscan.h
***************
*** 51,56 **** typedef struct HeapScanDescData
--- 51,69 ----
  	int			rs_mindex;		/* marked tuple's saved index */
  	int			rs_ntuples;		/* number of visible tuples on page */
  	OffsetNumber rs_vistuples[MaxHeapTuplesPerPage];	/* their offsets */
+ 
+ 	/* The random number generator state */
+ 	unsigned short rs_randstate[3];
+ 
+ 	/* TableSample Bernoulli Vitter's Algo samples */
+ 	bool		is_sample_scan;
+ 	int			sample_percent;
+ 	TableSampleMethod sample_method;
+ 	HeapTuple	*rs_samplerows;
+ 	int			rs_samplesize;
+ 	int			rs_curindex;
+ 	bool		rs_sampleinited;
+ 	int			targrows;
  }	HeapScanDescData;
  
  /*
*** a/src/include/commands/vacuum.h
--- b/src/include/commands/vacuum.h
***************
*** 170,177 **** extern void lazy_vacuum_rel(Relation onerel, VacuumStmt *vacstmt,
  extern void analyze_rel(Oid relid, VacuumStmt *vacstmt,
  			BufferAccessStrategy bstrategy);
  extern bool std_typanalyze(VacAttrStats *stats);
- extern double anl_random_fract(void);
- extern double anl_init_selection_state(int n);
- extern double anl_get_next_S(double t, int n, double *stateptr);
  
  #endif   /* VACUUM_H */
--- 170,174 ----
*** /dev/null
--- b/src/include/executor/nodeSamplescan.h
***************
*** 0 ****
--- 1,28 ----
+ /*-------------------------------------------------------------------------
+  *
+  * nodeSamplescan.h
+  *
+  *
+  *
+  * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  * src/include/executor/nodeSamplescan.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef NODESAMPLESCAN_H
+ #define NODESAMPLESCAN_H
+ 
+ #include "nodes/execnodes.h"
+ 
+ #define RAND_STATE_SIZE 128
+ 
+ extern SampleScanState *ExecInitSampleScan(SampleScan *node, EState *estate, int eflags);
+ extern TupleTableSlot *ExecSampleScan(SampleScanState *node);
+ extern void ExecEndSampleScan(SampleScanState *node);
+ extern void ExecSampleMarkPos(SampleScanState *node);
+ extern void ExecSampleRestrPos(SampleScanState *node);
+ extern void ExecReScanSampleScan(SampleScanState *node);
+ 
+ #endif   /* NODESAMPLESCAN_H */
*** a/src/include/nodes/execnodes.h
--- b/src/include/nodes/execnodes.h
***************
*** 1430,1435 **** typedef struct ValuesScanState
--- 1430,1455 ----
  	int			marked_idx;
  } ValuesScanState;
  
+ /* --------------
+  * This State struct should be decided by the algorithm used in Sampling
+  * method.
+  *
+  * SampleScanState: the run-time state associated with a single sample
+  * scan. This is the run-time dual of the SampleScan plan node: for
+  * each SampleScan in the Plan tree, we create a SampleScanState in
+  * the corresponding PlanState tree. A PlanState's associated Plan can
+  * be found via ss.ps.plan.
+  *
+  * --------------
+  */
+ 
+ typedef struct SampleScanState
+ {
+ 	/* parent class; first field is NodeTag */
+ 	ScanState			 ss;
+ } SampleScanState;
+ 
+ 
  /* ----------------
   *	 CteScanState information
   *
*** a/src/include/nodes/nodes.h
--- b/src/include/nodes/nodes.h
***************
*** 51,56 **** typedef enum NodeTag
--- 51,57 ----
  	T_BitmapOr,
  	T_Scan,
  	T_SeqScan,
+ 	T_SampleScan,
  	T_IndexScan,
  	T_IndexOnlyScan,
  	T_BitmapIndexScan,
***************
*** 96,101 **** typedef enum NodeTag
--- 97,103 ----
  	T_BitmapOrState,
  	T_ScanState,
  	T_SeqScanState,
+ 	T_SampleScanState,
  	T_IndexScanState,
  	T_IndexOnlyScanState,
  	T_BitmapIndexScanState,
***************
*** 171,176 **** typedef enum NodeTag
--- 173,179 ----
  	T_JoinExpr,
  	T_FromExpr,
  	T_IntoClause,
+ 	T_TableSampleInfo,
  
  	/*
  	 * TAGS FOR EXPRESSION STATE NODES (execnodes.h)
*** a/src/include/nodes/parsenodes.h
--- b/src/include/nodes/parsenodes.h
***************
*** 701,708 **** typedef struct RangeTblEntry
  	/*
  	 * Fields valid for a plain relation RTE (else zero):
  	 */
! 	Oid			relid;			/* OID of the relation */
! 	char		relkind;		/* relation kind (see pg_class.relkind) */
  
  	/*
  	 * Fields valid for a subquery RTE (else NULL):
--- 701,709 ----
  	/*
  	 * Fields valid for a plain relation RTE (else zero):
  	 */
! 	Oid			relid;				/* OID of the relation */
! 	TableSampleInfo *sample_info;	/* Fields for tablesampleinfo */
! 	char		relkind;			/* relation kind (see pg_class.relkind) */
  
  	/*
  	 * Fields valid for a subquery RTE (else NULL):
***************
*** 765,770 **** typedef struct RangeTblEntry
--- 766,772 ----
  	Oid			checkAsUser;	/* if valid, check access as this role */
  	Bitmapset  *selectedCols;	/* columns needing SELECT permission */
  	Bitmapset  *modifiedCols;	/* columns needing INSERT/UPDATE permission */
+ 
  } RangeTblEntry;
  
  /*
*** a/src/include/nodes/plannodes.h
--- b/src/include/nodes/plannodes.h
***************
*** 271,276 **** typedef struct Scan
--- 271,294 ----
  typedef Scan SeqScan;
  
  /* ----------------
+  * SampleScan node
+  *
+  * This is the information about a SampleScan that is fixed for a given Plan.
+  * SampleScanState holds the run-time(executor-time) state associated with a
+  * given ScanScan node.
+  *
+  * In addition to our parent class, we need only a single additional piece of
+  * information: the information contained in the TABLESAMPLE clause that corresponds
+  * to this SampleScan.
+  * ----------------
+  */
+ typedef struct SampleScan
+ {
+ 	Scan				scan;
+ 	TableSampleInfo	   *sample_info;
+ } SampleScan;
+ 
+ /* ----------------
   *		index scan node
   *
   * indexqualorig is an implicitly-ANDed list of index qual expressions, each
*** a/src/include/nodes/primnodes.h
--- b/src/include/nodes/primnodes.h
***************
*** 58,63 **** typedef enum OnCommitAction
--- 58,86 ----
  	ONCOMMIT_DROP				/* ON COMMIT DROP */
  } OnCommitAction;
  
+ /*---------
+  * TableSampleMethod - defines the methods for tablesample query
+  *---------
+  */
+ typedef enum TableSampleMethod
+ {
+ 	SAMPLE_BERNOULLI,
+ 	SAMPLE_SYSTEM
+ } TableSampleMethod;
+ 
+ /*--------
+  * TableSampleInfo - information related to a tablesample query
+  *-------
+  */
+ typedef struct TableSampleInfo
+ {
+ 	NodeTag				type;
+ 	int					sample_percent;
+ 	TableSampleMethod	sample_method;
+ 	bool				is_repeatable;
+ 	int					repeat_seed;
+ } TableSampleInfo;
+ 
  /*
   * RangeVar - range variable, used in FROM clauses
   *
***************
*** 65,70 **** typedef enum OnCommitAction
--- 88,94 ----
   * field is not used, and inhOpt shows whether to apply the operation
   * recursively to child tables.  In some contexts it is also useful to carry
   * a TEMP table indication here.
+  * Also support for TableSample.
   */
  typedef struct RangeVar
  {
***************
*** 77,82 **** typedef struct RangeVar
--- 101,108 ----
  	char		relpersistence; /* see RELPERSISTENCE_* in pg_class.h */
  	Alias	   *alias;			/* table alias & optional column aliases */
  	int			location;		/* token location, or -1 if unknown */
+ 
+ 	TableSampleInfo *sample_info; /* TABLESAMPLE clause, if any */
  } RangeVar;
  
  /*
*** a/src/include/nodes/relation.h
--- b/src/include/nodes/relation.h
***************
*** 98,103 **** typedef struct PlannerGlobal
--- 98,105 ----
  	Index		lastRowMarkId;	/* highest PlanRowMark ID assigned */
  
  	bool		transientPlan;	/* redo plan when TransactionXmin changes? */
+ 
+ 	bool		isCursorStmt;	/* Is this a cursor stmt? Only for Cursor Tablesample Check */
  } PlannerGlobal;
  
  /* macro for fetching the Plan associated with a SubPlan node */
***************
*** 362,367 **** typedef struct PlannerInfo
--- 364,373 ----
   *					EquivalenceClasses)
   *		has_eclass_joins - flag that EquivalenceClass joins are possible
   *
+  * The next field will be set true if there is tablesample clause presense in
+  * the query, otherwise false;
+  *		has_table_sample - flag for tablesample clause
+  *
   * Note: Keeping a restrictinfo list in the RelOptInfo is useful only for
   * base rels, because for a join rel the set of clauses that are treated as
   * restrict clauses varies depending on which sub-relations we choose to join.
***************
*** 435,440 **** typedef struct RelOptInfo
--- 441,449 ----
  	List	   *joininfo;		/* RestrictInfo structures for join clauses
  								 * involving this rel */
  	bool		has_eclass_joins;		/* T means joininfo is incomplete */
+ 
+ 	/* used if there is tablesample clause */
+ 	bool		has_table_sample;
  } RelOptInfo;
  
  /*
***************
*** 703,708 **** typedef struct Path
--- 712,719 ----
  #define PATH_REQ_OUTER(path)  \
  	((path)->param_info ? (path)->param_info->ppi_req_outer : (Relids) NULL)
  
+ 
+ 
  /*----------
   * IndexPath represents an index scan over a single index.
   *
*** a/src/include/optimizer/cost.h
--- b/src/include/optimizer/cost.h
***************
*** 51,56 **** extern PGDLLIMPORT double cpu_operator_cost;
--- 51,57 ----
  extern PGDLLIMPORT int effective_cache_size;
  extern Cost disable_cost;
  extern bool enable_seqscan;
+ extern bool enable_samplescan;
  extern bool enable_indexscan;
  extern bool enable_indexonlyscan;
  extern bool enable_bitmapscan;
***************
*** 84,89 **** extern void cost_functionscan(Path *path, PlannerInfo *root,
--- 85,91 ----
  				  RelOptInfo *baserel, ParamPathInfo *param_info);
  extern void cost_valuesscan(Path *path, PlannerInfo *root,
  				RelOptInfo *baserel, ParamPathInfo *param_info);
+ extern void cost_samplescan(Path *path, PlannerInfo *root, RelOptInfo *baserel);
  extern void cost_ctescan(Path *path, PlannerInfo *root, RelOptInfo *baserel);
  extern void cost_recursive_union(Plan *runion, Plan *nrterm, Plan *rterm);
  extern void cost_sort(Path *path, PlannerInfo *root,
*** a/src/include/optimizer/pathnode.h
--- b/src/include/optimizer/pathnode.h
***************
*** 32,37 **** extern bool add_path_precheck(RelOptInfo *parent_rel,
--- 32,38 ----
  
  extern Path *create_seqscan_path(PlannerInfo *root, RelOptInfo *rel,
  					Relids required_outer);
+ extern Path *create_samplescan_path(PlannerInfo *root, RelOptInfo *rel);
  extern IndexPath *create_index_path(PlannerInfo *root,
  				  IndexOptInfo *index,
  				  List *indexclauses,
*** a/src/include/parser/kwlist.h
--- b/src/include/parser/kwlist.h
***************
*** 54,59 **** PG_KEYWORD("authorization", AUTHORIZATION, TYPE_FUNC_NAME_KEYWORD)
--- 54,60 ----
  PG_KEYWORD("backward", BACKWARD, UNRESERVED_KEYWORD)
  PG_KEYWORD("before", BEFORE, UNRESERVED_KEYWORD)
  PG_KEYWORD("begin", BEGIN_P, UNRESERVED_KEYWORD)
+ PG_KEYWORD("bernoulli", BERNOULLI, UNRESERVED_KEYWORD)
  PG_KEYWORD("between", BETWEEN, COL_NAME_KEYWORD)
  PG_KEYWORD("bigint", BIGINT, COL_NAME_KEYWORD)
  PG_KEYWORD("binary", BINARY, TYPE_FUNC_NAME_KEYWORD)
***************
*** 358,363 **** PG_KEYWORD("sysid", SYSID, UNRESERVED_KEYWORD)
--- 359,365 ----
  PG_KEYWORD("system", SYSTEM_P, UNRESERVED_KEYWORD)
  PG_KEYWORD("table", TABLE, RESERVED_KEYWORD)
  PG_KEYWORD("tables", TABLES, UNRESERVED_KEYWORD)
+ PG_KEYWORD("tablesample", TABLESAMPLE, TYPE_FUNC_NAME_KEYWORD)
  PG_KEYWORD("tablespace", TABLESPACE, UNRESERVED_KEYWORD)
  PG_KEYWORD("temp", TEMP, UNRESERVED_KEYWORD)
  PG_KEYWORD("template", TEMPLATE, UNRESERVED_KEYWORD)
